/**
 * ORY Hydra
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here.
 *
 * OpenAPI spec version: latest
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/JSONWebKey'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./JSONWebKey'));
  } else {
    // Browser globals (root is window)
    if (!root.OryHydra) {
      root.OryHydra = {};
    }
    root.OryHydra.JSONWebKeySet = factory(root.OryHydra.ApiClient, root.OryHydra.JSONWebKey);
  }
}(this, function(ApiClient, JSONWebKey) {
  'use strict';




  /**
   * The JSONWebKeySet model module.
   * @module model/JSONWebKeySet
   * @version latest
   */

  /**
   * Constructs a new <code>JSONWebKeySet</code>.
   * @alias module:model/JSONWebKeySet
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>JSONWebKeySet</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/JSONWebKeySet} obj Optional instance to populate.
   * @return {module:model/JSONWebKeySet} The populated <code>JSONWebKeySet</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('keys')) {
        obj['keys'] = ApiClient.convertToType(data['keys'], [JSONWebKey]);
      }
    }
    return obj;
  }

  /**
   * The value of the \"keys\" parameter is an array of JWK values.  By default, the order of the JWK values within the array does not imply an order of preference among them, although applications of JWK Sets can choose to assign a meaning to the order for their purposes, if desired.
   * @member {Array.<module:model/JSONWebKey>} keys
   */
  exports.prototype['keys'] = undefined;



  return exports;
}));


