<?php
/**
 * VersionApi
 * PHP version 5
 *
 * @category Class
 * @package  HydraSDK
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ORY Hydra
 *
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here.
 *
 * OpenAPI spec version: latest
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HydraSDK\Api;

use \HydraSDK\ApiClient;
use \HydraSDK\ApiException;
use \HydraSDK\Configuration;
use \HydraSDK\ObjectSerializer;

/**
 * VersionApi Class Doc Comment
 *
 * @category Class
 * @package  HydraSDK
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class VersionApi
{
    /**
     * API Client
     *
     * @var \HydraSDK\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \HydraSDK\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\HydraSDK\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \HydraSDK\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \HydraSDK\ApiClient $apiClient set the API client
     *
     * @return VersionApi
     */
    public function setApiClient(\HydraSDK\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation getVersion
     *
     * Get service version
     *
     * Client for Hydra
     *
     * @throws \HydraSDK\ApiException on non-2xx response
     * @return \HydraSDK\Model\Version
     */
    public function getVersion()
    {
        list($response) = $this->getVersionWithHttpInfo();
        return $response;
    }

    /**
     * Operation getVersionWithHttpInfo
     *
     * Get service version
     *
     * Client for Hydra
     *
     * @throws \HydraSDK\ApiException on non-2xx response
     * @return array of \HydraSDK\Model\Version, HTTP status code, HTTP response headers (array of strings)
     */
    public function getVersionWithHttpInfo()
    {
        // parse inputs
        $resourcePath = "/version";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json', 'application/x-www-form-urlencoded']);


        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\HydraSDK\Model\Version',
                '/version'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\HydraSDK\Model\Version', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\HydraSDK\Model\Version', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
